using MicroFour.StrataFrame.Business;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Text;

namespace ComplexBOSample
{
    public partial class CompanyBO : MicroFour.StrataFrame.Business.BusinessLayer
    {
        #region Data Retrieval Methods

        

        #endregion

        #region Event Handlers

        /// <summary>
        /// Checks the business rules on the current row
        /// </summary>
        /// <param name="e"></param>
        /// <remarks></remarks>
        private void CompanyBO_CheckRulesOnCurrentRow(CheckRulesEventArgs e)
        {

        }

        /// <summary>
        /// Sets the default values for a new row
        /// </summary>
        /// <remarks></remarks>
        private void CompanyBO_SetDefaultValues()
        {

        }

        #endregion

        #region " Necessary Code for the Complex Business Object "

        private StateBO _State = new StateBO();

        /// <summary>
        /// Handles the CurrentDataTableRefilled event
        /// 
        /// In this method, you want to populate the 
        /// </summary>
        private void CompanyBO_CurrentDataTableRefilled()
        {
            //-- This fetches the states for the current Company row, so if this business object
            //   has more than one row, you'll have to get multiple rows.
            this._State.FillDataTable("SELECT * FROM State WHERE State.State = '" + (string)this.CurrentRow["State"] + "'");
        }

        /// <summary>
        /// This method handles the Navigated event of the Company business object to allow
        /// you to set the filter on the State business object.
        /// 
        /// You can filter the StateBO to only show records that match the current record
        /// within the CompanyBO.
        /// </summary>
        /// <param name="e"></param>
        private void CompanyBO_Navigated(NavigatedEventArgs e)
        {
            //-- Set the filter on the internal StateBO
            //   (Only necessary if the CompanyBO will contain more than one record)
            this._State.Filter = "whatever";
        }

        #endregion
    }
}
